// DirectShow JƉ𑜓xI_CAO{bNX\

#include <windows.h>
#include <vector>

using std::vector;

#include <tchar.h>
#include <dshow.h>
#include <stdio.h>
#include "resource.h"

#pragma comment(lib, "strmiids.lib")

//	𑜓xۑNX
struct RES{
	int	width;
	int height;
	double frame;
};

//	JۑNX
struct CAMERA{
	TCHAR name[256];
	vector<RES> res;
};


vector<CAMERA> camera;

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	J̈ꗗ擾Xg{bNXɐݒ
int cameraList(vector<CAMERA>& camera,HWND hList);

//	T|[gĂ𑜓xEt[[g擾
void resList(CAMERA& camera,IBaseFilter *pbf);

//	𑜓xvectorɕۑ
void bitmap_set(vector<RES>& res, VIDEOINFOHEADER* video);

int cameraNum=0;	//	Xg{bNXőIꂽJԍۑ
int cameraMax=0;	//	J
int resNum = 0;		//	Xg{bNXőIꂽ𑜓x


int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* CmdLine, int nCmdShow){
	TCHAR buf[64];
	// COM̏
	if(FAILED(CoInitialize(NULL))){
		MessageBox(0,_TEXT("COM̏Ɏs܂"),_TEXT("G["),MB_OK);
		return 1;
	}

	//	_CAO{bNX̕\
	if(DialogBox(hCurInst, TEXT("DLG1"), 0, (DLGPROC)DlgProc)==TRUE){
		vector<RES>& r = ::camera[::cameraNum].res;
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%s(%d*%d %5.1ffps)I܂B"), ::camera[::cameraNum].name, r[::resNum].width, r[::resNum].height, r[::resNum].frame);
		MessageBox(0,buf,_TEXT("J"),MB_OK);
	}
	CoUninitialize(); // COMI
	return 0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static HWND hList;
	static HWND REShList;
	int n,m;
	TCHAR buf[64];
	switch (msg) {
		case WM_INITDIALOG:{
			hList = GetDlgItem(hDlg, IDC_LISTBOX100);
			REShList = GetDlgItem(hDlg, IDC_LISTBOX110);
			::cameraMax = cameraList(::camera, hList);
			if (::cameraMax == 0){
				MessageBox(0, _TEXT("J݂܂"), _TEXT("G["), MB_OK);
				EndDialog(hDlg, FALSE);
			}
			for (n = 0; n < (int)::camera.size(); n++){
				SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)::camera[n].name);
			}
			vector<RES>& r = ::camera[::cameraNum].res;
			m = (int)r.size();
			for (n = 0; n < m; n++){
				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%5d*%5d %5.1ffps"), r[n].width, r[n].height, r[n].frame);
				SendMessage(REShList, LB_ADDSTRING, 0, (LPARAM)buf);
			}
			SendMessage(hList, LB_SETCURSEL, 0, 0);
			SendMessage(REShList, LB_SETCURSEL, 0, 0);
			return TRUE;
		}
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_LISTBOX100:	//	Xg{bNXւ̃bZ[W
					if (HIWORD(wParam)==LBN_SELCHANGE){
						n = (int)SendMessage(hList, LB_GETCURSEL, NULL, NULL);
						if (0 <= n){
							::cameraNum = n;
							vector<RES>& r = ::camera[::cameraNum].res;
							m = (int)r.size();
							SendMessage(REShList, LB_RESETCONTENT, 0, 0);
							for (n = 0; n < m; n++){
								_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%5d*%5d %5.1ffps"), r[n].width, r[n].height, r[n].frame);
								SendMessage(REShList, LB_ADDSTRING, 0, (LPARAM)buf);
							}
							SendMessage(REShList, LB_SETCURSEL, 0, 0);
							::resNum = n;
						}
					}
					break;
				case IDC_LISTBOX110:	//	Xg{bNXւ̃bZ[W
					if (HIWORD(wParam)==LBN_SELCHANGE){
						n = (int)SendMessage(REShList, LB_GETCURSEL, NULL, NULL);
						if (0 <= n){
							::resNum = n;
						}
					}
					break;
				case IDOK:
					EndDialog(hDlg,TRUE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return TRUE;
				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
	return TRUE;
}

//	J̈ꗗ擾Xg{bNXɐݒ

int cameraList(vector<CAMERA>& camera,HWND hList){
	// VXefoCX񋓎q̍쐬
	ICreateDevEnum *pDevEnum = NULL;
	CoCreateInstance(CLSID_SystemDeviceEnum, 
	NULL, CLSCTX_INPROC, IID_ICreateDevEnum, (void **)&pDevEnum);

	// 񋓎q̎擾
	IEnumMoniker *pClassEnum = NULL;
	pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
	if(pClassEnum == NULL){
		pDevEnum->Release();
		return 0;
	}

	ULONG cFetched;
	IMoniker *pMoniker = NULL;
	IBaseFilter *pbf = NULL;
	int n=0;
	while(pClassEnum->Next(1, &pMoniker, &cFetched) == S_OK){
		IPropertyBag *pP = NULL;
		VARIANT var;

		pMoniker->BindToStorage(0,0,IID_IPropertyBag,(void**)&pP);
		var.vt=VT_BSTR;
		pP->Read(_TEXT("FriendlyName"),&var,0);
		//	foCXXg{bNXɓo^
		CAMERA* c=new CAMERA;
		_tcscpy_s(c->name,sizeof(c->name)/sizeof(TCHAR),var.bstrVal);
		VariantClear(&var);

		pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&pbf); // jJtB^IuWFNgɃoCh
		resList(*c, pbf);

		camera.push_back(*c);

		pMoniker->Release();
		++n;
	}	
	pDevEnum->Release(); // Ȍɕsvȃ[[X
	pClassEnum->Release();
	return n;
}

//	T|[gĂ𑜓xEt[[g擾

void resList(CAMERA& camera,IBaseFilter *pbf){
	HRESULT hr;

	// Lv`Ot쐬
	ICaptureGraphBuilder2 *pCapture = NULL;
	CoCreateInstance(CLSID_CaptureGraphBuilder2, 
	NULL, CLSCTX_INPROC, IID_ICaptureGraphBuilder2, (void **) &pCapture);
	// rfItH[}bg̎擾
	IAMStreamConfig *pConfig = NULL;
	hr = pCapture->FindInterface(&PIN_CATEGORY_CAPTURE, 
	0, pbf, IID_IAMStreamConfig, (void**)&pConfig); // C^[tFCX̃|C^擾

	int iCount=0;
	int	iSize=0;
	hr = pConfig->GetNumberOfCapabilities(&iCount, &iSize);
	if(iSize == sizeof(VIDEO_STREAM_CONFIG_CAPS)){// VIDEO_STREAM_CONFIG_CAPS\̂TCYmF
		for(int iFormat=0; iFormat<iCount; iFormat++){
			VIDEO_STREAM_CONFIG_CAPS scc;
			AM_MEDIA_TYPE *pmtConfig;
			hr = pConfig->GetStreamCaps(iFormat, &pmtConfig, (BYTE*)&scc);
			VIDEOINFOHEADER *pVih2;
			int u=-1;
			if(SUCCEEDED(hr)){
				if((pmtConfig->majortype == MEDIATYPE_Video)
					&& (pmtConfig->formattype == FORMAT_VideoInfo)
					&& (pmtConfig->cbFormat >= sizeof(VIDEOINFOHEADER))
					&& (pmtConfig->pbFormat != NULL)){

					pVih2 = (VIDEOINFOHEADER*)pmtConfig->pbFormat;
					bitmap_set(camera.res , pVih2);
					u = (int)camera.res.size();
				}
			}
		}
	}
	pConfig->Release();
	pCapture->Release();
}

//	𑜓xvectorɕۑ

void bitmap_set(vector<RES>& res, VIDEOINFOHEADER* video){
	double ns = 100 * 1.0e-9;
	double frame = 1 / (double(video->AvgTimePerFrame)*ns);
	RES* r = new RES;
	r->frame = frame;
	r->width = video->bmiHeader.biWidth;
	r->height = video->bmiHeader.biHeight;
	res.push_back(*r);
}
